std::deque< _Tp, _Alloc > Class Template Reference
Sequences
Inheritance diagram for std::deque< _Tp, _Alloc >:
[legend]

## Public Types

typedef _Alloc | allocator_type
typedef _Base::const_iterator | const_iterator
typedef _Tp_alloc_type::const_pointer | const_pointer
typedef _Tp_alloc_type::const_reference | const_reference
typedef std::reverse_iterator < const_iterator > | const_reverse_iterator
typedef ptrdiff_t | difference_type
typedef _Base::iterator | iterator
typedef _Tp_alloc_type::pointer | pointer
typedef _Tp_alloc_type::reference | reference
typedef std::reverse_iterator < iterator > | reverse_iterator
typedef size_t | size_type
typedef _Tp | value_type

## Public Member Functions

| deque ()
| deque (const allocator_type &__a)
| deque (size_type __n)
| deque (size_type __n, const value_type &__value, const allocator_type &__a=allocator_type())
| deque (const deque &__x)
| deque (deque &&__x)
| deque (initializer_list< value_type > __l, const allocator_type &__a=allocator_type())
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>>
| deque (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
| ~deque () noexcept
template<typename... _Args>
deque< _Tp, _Alloc >::iterator | _M_insert_aux (iterator __pos, _Args &&...__args)
void | assign (size_type __n, const value_type &__val)
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>>
void | assign (_InputIterator __first, _InputIterator __last)
void | assign (initializer_list< value_type > __l)
reference | at (size_type __n)
const_reference | at (size_type __n) const
reference | back ()
const_reference | back () const
iterator | begin () noexcept
const_iterator | begin () const noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
template<typename... _Args>
deque< _Tp, _Alloc >::iterator | emplace (const_iterator __position, _Args &&...__args)
template<typename... _Args>
iterator | emplace (const_iterator __position, _Args &&...__args)
template<typename... _Args>
void | emplace_back (_Args &&...__args)
template<typename... _Args>
void | emplace_front (_Args &&...__args)
bool | empty () const noexcept
iterator | end () noexcept
const_iterator | end () const noexcept
iterator | erase (const_iterator __position)
iterator | erase (const_iterator __first, const_iterator __last)
reference | front ()
const_reference | front () const
allocator_type | get_allocator () const noexcept
iterator | insert (const_iterator __position, const value_type &__x)
iterator | insert (const_iterator __position, value_type &&__x)
iterator | insert (const_iterator __p, initializer_list< value_type > __l)
iterator | insert (const_iterator __position, size_type __n, const value_type &__x)
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>>
iterator | insert (const_iterator __position, _InputIterator __first, _InputIterator __last)
size_type | max_size () const noexcept
deque & | operator= (const deque &__x)
deque & | operator= (deque &&__x)
deque & | operator= (initializer_list< value_type > __l)
reference | operator[] (size_type __n)
const_reference | operator[] (size_type __n) const
void | pop_back ()
void | pop_front ()
void | push_back (const value_type &__x)
void | push_back (value_type &&__x)
void | push_front (const value_type &__x)
void | push_front (value_type &&__x)
reverse_iterator | rbegin () noexcept
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rend () noexcept
const_reverse_iterator | rend () const noexcept
void | resize (size_type __new_size)
void | resize (size_type __new_size, const value_type &__x)
void | shrink_to_fit ()
size_type | size () const noexcept
void | swap (deque &__x)

## Protected Types

enum | { _S_initial_map_size }
typedef _Alloc::template rebind< _Tp * >::other | _Map_alloc_type
typedef pointer * | _Map_pointer

## Protected Member Functions

_Tp ** | _M_allocate_map (size_t __n)
_Tp * | _M_allocate_node ()
template<typename _InputIterator >
void | _M_assign_aux (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _ForwardIterator >
void | _M_assign_aux (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _Integer >
void | _M_assign_dispatch (_Integer __n, _Integer __val, __true_type)
template<typename _InputIterator >
void | _M_assign_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
void | _M_create_nodes (_Tp **__nstart, _Tp **__nfinish)
void | _M_deallocate_map (_Tp **__p, size_t __n)
void | _M_deallocate_node (_Tp *__p)
void | _M_default_append (size_type __n)
void | _M_default_initialize ()
template<typename _Alloc1 >
void | _M_destroy_data (iterator __first, iterator __last, const _Alloc1 &)
void | _M_destroy_data (iterator __first, iterator __last, const std::allocator< _Tp > &)
void | _M_destroy_data_aux (iterator __first, iterator __last)
void | _M_destroy_nodes (_Tp **__nstart, _Tp **__nfinish)
iterator | _M_erase (iterator __pos)
iterator | _M_erase (iterator __first, iterator __last)
void | _M_erase_at_begin (iterator __pos)
void | _M_erase_at_end (iterator __pos)
void | _M_fill_assign (size_type __n, const value_type &__val)
void | _M_fill_initialize (const value_type &__value)
void | _M_fill_insert (iterator __pos, size_type __n, const value_type &__x)
_Map_alloc_type | _M_get_map_allocator () const noexcept
_Tp_alloc_type & | _M_get_Tp_allocator () noexcept
const _Tp_alloc_type & | _M_get_Tp_allocator () const noexcept
template<typename _Integer >
void | _M_initialize_dispatch (_Integer __n, _Integer __x, __true_type)
template<typename _InputIterator >
void | _M_initialize_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
void | _M_initialize_map (size_t)
template<typename... _Args>
iterator | _M_insert_aux (iterator __pos, _Args &&...__args)
void | _M_insert_aux (iterator __pos, size_type __n, const value_type &__x)
template<typename _ForwardIterator >
void | _M_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, size_type __n)
template<typename _Integer >
void | _M_insert_dispatch (iterator __pos, _Integer __n, _Integer __x, __true_type)
template<typename _InputIterator >
void | _M_insert_dispatch (iterator __pos, _InputIterator __first, _InputIterator __last, __false_type)
void | _M_range_check (size_type __n) const
template<typename _InputIterator >
void | _M_range_insert_aux (iterator __pos, _InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _ForwardIterator >
void | _M_range_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
bool | _M_shrink_to_fit ()
template<typename _InputIterator >
void | _M_range_initialize (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _ForwardIterator >
void | _M_range_initialize (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename... _Args>
void | _M_push_back_aux (_Args &&...__args)
template<typename... _Args>
void | _M_push_front_aux (_Args &&...__args)
void | _M_pop_back_aux ()
void | _M_pop_front_aux ()
iterator | _M_reserve_elements_at_front (size_type __n)
iterator | _M_reserve_elements_at_back (size_type __n)
void | _M_new_elements_at_front (size_type __new_elements)
void | _M_new_elements_at_back (size_type __new_elements)
void | _M_reserve_map_at_back (size_type __nodes_to_add=1)
void | _M_reserve_map_at_front (size_type __nodes_to_add=1)
void | _M_reallocate_map (size_type __nodes_to_add, bool __add_at_front)

## Static Protected Member Functions

static size_t | _S_buffer_size ()

## Protected Attributes

_Deque_impl | _M_impl

## Detailed Description

### template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
class std::deque< _Tp, _Alloc >

A standard container using fixed-size memory allocation and constant-time manipulation of elements at either end.

Template Parameters

  _Tp | Type of element.
  _Alloc | Allocator type, defaults to allocator<_Tp>.

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements.

In previous HP/SGI versions of deque, there was an extra template parameter so users could control the node size. This extension turned out to violate the C++ standard (it can be detected using template template parameters), and it was removed.

Here's how a deque<Tp> manages memory. Each deque has 4 members:

- Tp** _M_map
- size_t _M_map_size
- iterator _M_start, _M_finish

map_size is at least 8. map is an array of map_size pointers-to-nodes. (The name map has nothing to do with the std::map class, and nodes should not be confused with std::list's usage of node.)

A node has no specific type name as such, but it is referred to as node in this file. It is a simple array-of-Tp. If Tp is very large, there will be one Tp element per node (i.e., an array of one). For non-huge Tp's, node size is inversely related to Tp size: the larger the Tp, the fewer Tp's will fit in a node. The goal here is to keep the total size of a node relatively small and constant over different Tp's, to improve allocator efficiency.

Not every pointer in the map array will point to a node. If the initial number of elements in the deque is small, the /middle/ map pointers will be valid, and the ones at the edges will be unused. This same situation will arise as the map grows: available map pointers, if any, will be on the ends. As new nodes are created, only a subset of the map's pointers need to be copied outward.

Class invariants:

- For any nonsingular iterator i:
  - i.node points to a member of the map array. (Yes, you read that correctly: i.node does not actually point to a node.) The member of the map array is what actually points to the node.
  - i.first == *(i.node) (This points to the node (first Tp element).)
  - i.last == i.first + node_size
  - i.cur is a pointer in the range [i.first, i.last). NOTE: the implication of this is that i.cur is always a dereferenceable pointer, even if i is a past-the-end iterator.
- Start and Finish are always nonsingular iterators. NOTE: this means that an empty deque must have one node, a deque with <N elements (where N is the node buffer size) must have one node, a deque with N through (2N-1) elements must have two nodes, etc.
- For every node other than start.node and finish.node, every element in the node is an initialized object. If start.node == finish.node, then [start.cur, finish.cur) are initialized objects, and the elements outside that range are uninitialized storage. Otherwise, [start.cur, start.last) and [finish.first, finish.cur) are initialized objects, and [start.first, start.cur) and [finish.cur, finish.last) are uninitialized storage.
- [map, map + map_size) is a valid, non-empty range.
- [start.node, finish.node] is a valid range contained within [map, map + map_size).

- A pointer in the range [map, map + map_size) points to an allocated node if and only if the pointer is in the range [start.node, finish.node].

  Here's the magic: nothing in deque is aware of the discontiguous storage!

  The memory setup and layout occurs in the parent, _Base, and the iterator class is entirely responsible for leaping from one node to the next. All the implementation routines for deque itself work only through the start and finish iterators. This keeps the routines simple and sane, and we can use other standard algorithms as well.

Definition at line 734 of file stl_deque.h.

## Constructor & Destructor Documentation

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( |  | ) |

inline

Default constructor creates no elements.

Definition at line 786 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | const allocator_type & | __a | ) |

inlineexplicit

Creates a deque with no elements.

Parameters

  __a | An allocator object.

Definition at line 794 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | size_type | __n | ) |

inlineexplicit

Creates a deque with default constructed elements.

Parameters

  __n | The number of elements to initially create.

This constructor fills the deque with n default constructed elements.

Definition at line 806 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | size_type | __n,
|  | const value_type & | __value,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Creates a deque with copies of an exemplar element.

Parameters

  __n | The number of elements to initially create.
  __value | An element to copy.
  __a | An allocator.

This constructor fills the deque with __n copies of __value.

Definition at line 818 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_fill_initialize().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | const deque< _Tp, _Alloc > & | __x | ) |

inline

Deque copy constructor.

Parameters

  __x | A deque of identical element and allocator types.

The newly-created deque uses a copy of the allocation object used by __x.

Definition at line 845 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin(), and std::deque< _Tp, _Alloc >::end().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | deque< _Tp, _Alloc > && | __x | ) |

inline

Deque move constructor.

Parameters

  __x | A deque of identical element and allocator types.

The newly-created deque contains the exact contents of __x. The contents of __x are a valid, but unspecified deque.

Definition at line 859 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | initializer_list< value_type > | __l,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Builds a deque from an initializer list.

Parameters

  __l | An initializer_list.
  __a | An allocator object.

Create a deque consisting of copies of the elements in the initializer_list __l.

This will call the element type's copy constructor N times (where N is __l.size()) and do no memory reallocation.

Definition at line 873 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_range_initialize().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>>

std::deque< _Tp, _Alloc >::deque | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Builds a deque from a range.

Parameters

  __first | An input iterator.
  __last | An input iterator.
  __a | An allocator object.

Create a deque consisting of copies of the elements from [__first, __last).

If the iterators are forward, bidirectional, or random-access, then this will call the elements' copy constructor N times (where N is distance(__first,__last)) and do no memory reallocation. But if only input iterators are used, then this will do at most 2N calls to the copy constructor, and logN memory reallocations.

Definition at line 900 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::~deque | ( |  | ) |

inlinenoexcept

The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 921 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin(), and std::deque< _Tp, _Alloc >::end().

## Member Function Documentation

template<typename _Tp , typename _Alloc >

void deque::_M_fill_initialize | ( | const value_type & | __value | ) |

protected

Fills the deque with copies of value.

Parameters

  __value | Initial value.

Returns
  Nothing.

Precondition
  _M_start and _M_finish have already been initialized, but none of the deque's elements have yet been constructed.

This function is called only when the user provides an explicit size (with or without an explicit exemplar value).

Definition at line 356 of file deque.tcc.

References std::_Destroy().

Referenced by std::deque< _Tp, _Alloc >::deque().

template<typename _Tp , typename _Alloc >

void std::_Deque_base< _Tp, _Alloc >::_M_initialize_map | ( | size_t | __num_elements | ) |

protectedinherited

Layout storage.

Parameters

  __num_elements | The count of T's for which to allocate space at first.

Returns
  Nothing.

The initial underlying memory layout is a bit complicated...

Definition at line 586 of file stl_deque.h.

References std::max().

template<typename _Tp , typename _Alloc >

void deque::_M_new_elements_at_back | ( | size_type | __new_elements | ) |

protected

Memory-handling helpers for the previous internal insert functions.

Definition at line 854 of file deque.tcc.

References std::size().

Referenced by std::deque< _Tp, _Alloc >::_M_reserve_elements_at_back().

template<typename _Tp , typename _Alloc >

void deque::_M_new_elements_at_front | ( | size_type | __new_elements | ) |

protected

Memory-handling helpers for the previous internal insert functions.

Definition at line 829 of file deque.tcc.

References std::size().

Referenced by std::deque< _Tp, _Alloc >::_M_reserve_elements_at_front().

template<typename _Tp , typename _Alloc >

void deque::_M_pop_back_aux | ( |  | ) |

protected

Helper functions for push_* and pop_*.

Definition at line 510 of file deque.tcc.

Referenced by std::deque< _Tp, _Alloc >::pop_back().

template<typename _Tp , typename _Alloc >

void deque::_M_pop_front_aux | ( |  | ) |

protected

Helper functions for push_* and pop_*.

Definition at line 525 of file deque.tcc.

Referenced by std::deque< _Tp, _Alloc >::pop_front().

template<typename _Tp , typename _Alloc >
template<typename... _Args>

void deque::_M_push_back_aux | ( | _Args &&... | __args | ) |

protected

Helper functions for push_* and pop_*.

Definition at line 444 of file deque.tcc.

Referenced by std::deque< _Tp, _Alloc >::push_back().

template<typename _Tp , typename _Alloc >
template<typename... _Args>

void deque::_M_push_front_aux | ( | _Args &&... | __args | ) |

protected

Helper functions for push_* and pop_*.

Definition at line 478 of file deque.tcc.

Referenced by std::deque< _Tp, _Alloc >::push_front().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_range_check | ( | size_type | __n | ) | const

inlineprotected

Safety check used only from at().

Definition at line 1269 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::size().

Referenced by std::deque< _Tp, _Alloc >::at().

template<typename _Tp , typename _Alloc >
template<typename _InputIterator >

void deque::_M_range_initialize | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | std::input_iterator_tag |
| ) |  |

protected

Fills the deque with whatever is in [first,last).

Parameters

  __first | An input iterator.
  __last | An input iterator.

Returns
  Nothing.

If the iterators are actually forward iterators (or better), then the memory layout can be done all at once. Else we move forward using push_back on each value from the iterator.

Definition at line 382 of file deque.tcc.

Referenced by std::deque< _Tp, _Alloc >::deque().

template<typename _Tp , typename _Alloc >
template<typename _ForwardIterator >

void deque::_M_range_initialize | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | std::forward_iterator_tag |
| ) |  |

protected

Fills the deque with whatever is in [first,last).

Parameters

  __first | An input iterator.
  __last | An input iterator.

Returns
  Nothing.

If the iterators are actually forward iterators (or better), then the memory layout can be done all at once. Else we move forward using push_back on each value from the iterator.

Definition at line 406 of file deque.tcc.

References std::_Destroy(), std::advance(), and std::distance().

template<typename _Tp , typename _Alloc >

void deque::_M_reallocate_map | ( | size_type | __nodes_to_add,
|  | bool | __add_at_front
| ) |  |

protected

Memory-handling helpers for the major map.

Makes sure the _M_map has space for new nodes. Does not actually add the nodes. Can invalidate _M_map pointers. (And consequently, deque iterators.)

Definition at line 879 of file deque.tcc.

References std::max().

Referenced by std::deque< _Tp, _Alloc >::_M_reserve_map_at_back(), and std::deque< _Tp, _Alloc >::_M_reserve_map_at_front().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::_M_reserve_elements_at_back | ( | size_type | __n | ) |

inlineprotected

Memory-handling helpers for the previous internal insert functions.

Definition at line 1966 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_new_elements_at_back().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::_M_reserve_elements_at_front | ( | size_type | __n | ) |

inlineprotected

Memory-handling helpers for the previous internal insert functions.

Definition at line 1956 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_new_elements_at_front().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_reserve_map_at_back | ( | size_type | __nodes_to_add = `1` | ) |

inlineprotected

Memory-handling helpers for the major map.

Makes sure the _M_map has space for new nodes. Does not actually add the nodes. Can invalidate _M_map pointers. (And consequently, deque iterators.)

Definition at line 1992 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_reallocate_map().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::_M_reserve_map_at_front | ( | size_type | __nodes_to_add = `1` | ) |

inlineprotected

Memory-handling helpers for the major map.

Makes sure the _M_map has space for new nodes. Does not actually add the nodes. Can invalidate _M_map pointers. (And consequently, deque iterators.)

Definition at line 2000 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_reallocate_map().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::assign | ( | size_type | __n,
|  | const value_type & | __val
| ) |  |

inline

Assigns a given value to a deque.

Parameters

  __n | Number of elements to be assigned.
  __val | Value to be assigned.

This function fills a deque with n copies of the given value. Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 982 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::operator=().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>>

void std::deque< _Tp, _Alloc >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last
| ) |  |

inline

Assigns a range to a deque.

Parameters

  __first | An input iterator.
  __last | An input iterator.

This function fills a deque with copies of the elements in the range [__first,__last).

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 1001 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::assign | ( | initializer_list< value_type > | __l | ) |

inline

Assigns an initializer list to a deque.

Parameters

  __l | An initializer_list.

This function fills a deque with copies of the elements in the initializer_list __l.

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 1026 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::assign().

Referenced by std::deque< _Tp, _Alloc >::assign().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::at | ( | size_type | __n | ) |

inline

Provides access to the data contained in the deque.

Parameters

  __n | The index of the element for which data should be accessed.

Returns
  Read/write reference to data.

Exceptions

  std::out_of_range | If __n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 1288 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_range_check().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::at | ( | size_type | __n | ) | const

inline

Provides access to the data contained in the deque.

Parameters

  __n | The index of the element for which data should be accessed.

Returns
  Read-only (constant) reference to data.

Exceptions

  std::out_of_range | If __n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 1306 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_range_check().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::back | ( |  | ) |

inline

Returns a read/write reference to the data at the last element of the deque.

Definition at line 1333 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::end().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::back | ( |  | ) | const

inline

Returns a read-only (constant) reference to the data at the last element of the deque.

Definition at line 1345 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::end().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::begin | ( |  | ) |

inlinenoexcept

Returns a read/write iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Definition at line 1041 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::clear(), std::deque< _Tp, _Alloc >::deque(), std::deque< _Tp, _Alloc >::front(), std::deque< _Tp, _Alloc >::insert(), std::deque< _Tp, _Alloc >::operator=(), std::operator==(), and std::deque< _Tp, _Alloc >::~deque().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::begin | ( |  | ) | const

inlinenoexcept

Returns a read-only (constant) iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Definition at line 1049 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::cbegin | ( |  | ) | const

inlinenoexcept

Returns a read-only (constant) iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Definition at line 1112 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::insert().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::cend | ( |  | ) | const

inlinenoexcept

Returns a read-only (constant) iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Definition at line 1121 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::clear | ( |  | ) |

inlinenoexcept

Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1678 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin().

Referenced by std::deque< _Tp, _Alloc >::operator=().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::crbegin | ( |  | ) | const

inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Definition at line 1130 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::crend | ( |  | ) | const

inlinenoexcept

Returns a read-only (constant) reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Definition at line 1139 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename... _Args>

iterator std::deque< _Tp, _Alloc >::emplace | ( | const_iterator | __position,
|  | _Args &&... | __args
| ) |  |

Inserts an object in deque before specified iterator.

Parameters

  __position | A const_iterator into the deque.
  __args | Arguments.

Returns
  An iterator that points to the inserted data.

This function will insert an object of type T constructed with T(std::forward<Args>(args)...) before the specified location.

Referenced by std::deque< _Tp, _Alloc >::insert().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

bool std::deque< _Tp, _Alloc >::empty | ( |  | ) | const

inlinenoexcept

Returns true if the deque is empty. (Thus begin() would equal end().)

Definition at line 1232 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::end | ( |  | ) |

inlinenoexcept

Returns a read/write iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Definition at line 1058 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::back(), std::deque< _Tp, _Alloc >::deque(), std::deque< _Tp, _Alloc >::operator=(), std::operator==(), and std::deque< _Tp, _Alloc >::~deque().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::end | ( |  | ) | const

inlinenoexcept

Returns a read-only (constant) iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Definition at line 1067 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::erase | ( | const_iterator | __position | ) |

inline

Remove element at given position.

Parameters

  __position | Iterator pointing to element to be erased.

Returns
  An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the deque by one.

The user is cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1618 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::erase | ( | const_iterator | __first,
|  | const_iterator | __last
| ) |  |

inline

Remove a range of elements.

Parameters

  __first | Iterator pointing to the first element to be erased.
  __last | Iterator pointing to one past the last element to be erased.

Returns
  An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [__first,__last) and shorten the deque accordingly.

The user is cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1642 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::front | ( |  | ) |

inline

Returns a read/write reference to the data at the first element of the deque.

Definition at line 1317 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::front | ( |  | ) | const

inline

Returns a read-only (constant) reference to the data at the first element of the deque.

Definition at line 1325 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

allocator_type std::deque< _Tp, _Alloc >::get_allocator | ( |  | ) | const

inlinenoexcept

Get a copy of the memory allocation object.

Definition at line 1032 of file stl_deque.h.

template<typename _Tp , typename _Alloc >

deque< _Tp, _Alloc >::iterator deque::insert | ( | const_iterator | __position,
|  | const value_type & | __x
| ) |  |

Inserts given value into deque before specified iterator.

Parameters

  __position | A const_iterator into the deque.
  __x | Data to be inserted.

Returns
  An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location.

Definition at line 175 of file deque.tcc.

Referenced by std::deque< _Tp, _Alloc >::resize().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::insert | ( | const_iterator | __position,
|  | value_type && | __x
| ) |  |

inline

Inserts given rvalue into deque before specified iterator.

Parameters

  __position | A const_iterator into the deque.
  __x | Data to be inserted.

Returns
  An iterator that points to the inserted data.

This function will insert a copy of the given rvalue before the specified location.

Definition at line 1508 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::emplace().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::insert | ( | const_iterator | __p,
|  | initializer_list< value_type > | __l
| ) |  |

inline

Inserts an initializer list into the deque.

Parameters

  __p | An iterator into the deque.
  __l | An initializer_list.

This function will insert copies of the data in the initializer_list __l into the deque before the location specified by __p. This is known as list insert.

Definition at line 1521 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::insert().

Referenced by std::deque< _Tp, _Alloc >::insert().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::insert | ( | const_iterator | __position,
|  | size_type | __n,
|  | const value_type & | __x
| ) |  |

inline

Inserts a number of copies of given data into the deque.

Parameters

  __position | A const_iterator into the deque.
  __n | Number of elements to be inserted.
  __x | Data to be inserted.

Returns
  An iterator that points to the inserted data.

This function will insert a specified number of copies of the given data before the location specified by __position.

Definition at line 1537 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin(), and std::deque< _Tp, _Alloc >::cbegin().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>>

iterator std::deque< _Tp, _Alloc >::insert | ( | const_iterator | __position,
|  | _InputIterator | __first,
|  | _InputIterator | __last
| ) |  |

inline

Inserts a range into the deque.

Parameters

  __position | A const_iterator into the deque.
  __first | An input iterator.
  __last | An input iterator.

Returns
  An iterator that points to the inserted data.

This function will insert copies of the data in the range [__first,__last) into the deque before the location specified by __position. This is known as range insert.

Definition at line 1573 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::begin(), and std::deque< _Tp, _Alloc >::cbegin().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::deque< _Tp, _Alloc >::max_size | ( |  | ) | const

inlinenoexcept

Returns the size() of the largest possible deque.

Definition at line 1151 of file stl_deque.h.

template<typename _Tp , typename _Alloc >

deque< _Tp, _Alloc > & deque::operator= | ( | const deque< _Tp, _Alloc > & | __x | ) |

Deque assignment operator.

Parameters

  __x | A deque of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 93 of file deque.tcc.

References std::deque< _Tp, _Alloc >::begin(), std::deque< _Tp, _Alloc >::end(), std::deque< _Tp, _Alloc >::size(), and std::size().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

deque& std::deque< _Tp, _Alloc >::operator= | ( | deque< _Tp, _Alloc > && | __x | ) |

inline

Deque move assignment operator.

Parameters

  __x | A deque of identical element and allocator types.

The contents of __x are moved into this deque (without copying). __x is a valid, but unspecified deque.

Definition at line 943 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::clear(), and std::deque< _Tp, _Alloc >::swap().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

deque& std::deque< _Tp, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) |

inline

Assigns an initializer list to a deque.

Parameters

  __l | An initializer_list.

This function fills a deque with copies of the elements in the initializer_list __l.

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 964 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::assign().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) |

inline

Subscript access to the data contained in the deque.

Parameters

  __n | The index of the element for which data should be accessed.

Returns
  Read/write reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 1248 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | const

inline

Subscript access to the data contained in the deque.

Parameters

  __n | The index of the element for which data should be accessed.

Returns
  Read-only (constant) reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 1263 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::pop_back | ( |  | ) |

inline

Removes last element.

This is a typical stack operation. It shrinks the deque by one.

Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called.

Definition at line 1446 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_pop_back_aux().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::pop_front | ( |  | ) |

inline

Removes first element.

This is a typical stack operation. It shrinks the deque by one.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop_front() is called.

Definition at line 1425 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_pop_front_aux().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::push_back | ( | const value_type & | __x | ) |

inline

Add data to the end of the deque.

Parameters

  __x | Data to be added.

This is a typical stack operation. The function creates an element at the end of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 1394 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_push_back_aux().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::push_front | ( | const value_type & | __x | ) |

inline

Add data to the front of the deque.

Parameters

  __x | Data to be added.

This is a typical stack operation. The function creates an element at the front of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Definition at line 1363 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::_M_push_front_aux().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::deque< _Tp, _Alloc >::rbegin | ( |  | ) |

inlinenoexcept

Returns a read/write reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Definition at line 1076 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::rbegin | ( |  | ) | const

inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Definition at line 1085 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::deque< _Tp, _Alloc >::rend | ( |  | ) |

inlinenoexcept

Returns a read/write reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Definition at line 1094 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::rend | ( |  | ) | const

inlinenoexcept

Returns a read-only (constant) reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Definition at line 1103 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::resize | ( | size_type | __new_size | ) |

inline

Resizes the deque to the specified number of elements.

Parameters

  __new_size | Number of elements the deque should contain.

This function will resize the deque to the specified number of elements. If the number is smaller than the deque's current size the deque is truncated, otherwise default constructed elements are appended.

Definition at line 1165 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::size().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::resize | ( | size_type | __new_size,
|  | const value_type & | __x
| ) |  |

inline

Resizes the deque to the specified number of elements.

Parameters

  __new_size | Number of elements the deque should contain.
  __x | Data with which new elements should be populated.

This function will resize the deque to the specified number of elements. If the number is smaller than the deque's current size the deque is truncated, otherwise the deque is extended and new elements are populated with given data.

Definition at line 1187 of file stl_deque.h.

References std::deque< _Tp, _Alloc >::insert(), and std::deque< _Tp, _Alloc >::size().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::shrink_to_fit | ( |  | ) |

inline

A non-binding request to reduce memory use.

Definition at line 1223 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::deque< _Tp, _Alloc >::size | ( |  | ) | const

inlinenoexcept

Returns the number of elements in the deque.

Definition at line 1146 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::_M_range_check(), std::deque< _Tp, _Alloc >::operator=(), std::operator==(), and std::deque< _Tp, _Alloc >::resize().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::swap | ( | deque< _Tp, _Alloc > & | __x | ) |

inline

Swaps data with another deque.

Parameters

  __x | A deque of the same element and allocator types.

This exchanges the elements between two deques in constant time. (Four pointers, so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(d1,d2) will feed to this function.

Definition at line 1658 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::operator=(), and std::swap().

The documentation for this class was generated from the following files:

- stl_deque.h
- deque.tcc